#include "stdafx.h"
#include "ArcEntryInfo.h"
#include "../Utilities/FileOperation.h"

ARCHIVE_ENTRY_INFO_TREE* ARCHIVE_ENTRY_INFO_TREE::GetChild(size_t idx)const
{
	if(0<=idx && idx<GetNumChildren()){
		return childrenArray[idx];
	}else return NULL;
}

ARCHIVE_ENTRY_INFO_TREE* ARCHIVE_ENTRY_INFO_TREE::GetChild(LPCTSTR lpName)const
{
	CString strTmp=lpName;
	strTmp.MakeLower();
	DICT::const_iterator ite=childrenDict.find((LPCTSTR)strTmp);
	if(ite!=childrenDict.end()){
		return (*ite).second;
	}else return NULL;
}

void ARCHIVE_ENTRY_INFO_TREE::EnumFiles(std::list<CString> &rFileList)const
{
	if(bDir){
		size_t size=childrenArray.size();
		for(size_t i=0;i<size;i++){
			childrenArray[i]->EnumFiles(rFileList);
		}
	}
	if(!strFullPath.IsEmpty()){
		rFileList.push_back(strFullPath);
	}
}


//---------------
void ArcEntryInfoTree_GetNodePathRelative(const ARCHIVE_ENTRY_INFO_TREE* lpNode,const ARCHIVE_ENTRY_INFO_TREE* lpBase,CString &strPath)
{
	//Ŗʓ|ȂƂĂ̂́A
	//lpBasetpXĂȂ(=LhaForgezIɍotH_)Ƃ邩B
	strPath=_T("");

	for(; lpNode->lpParent && lpBase!=lpNode ;lpNode=lpNode->lpParent){
		CString strTmp=lpNode->strTitle;
		strTmp.Replace(_T('/'),_T('\\'));

		CPath strBuffer=strTmp;
		if(-1!=strTmp.Find(_T('\\'))){
			//fBNgm[h̖OɃpX؂蕶̂́AKw\𖳎ꗗ̎̂݁B
			//̂Ƃ́ApX؂S΂KvB
			strBuffer.StripPath();	//ԍŌ̕cāApXJbg
			strBuffer.RemoveBackslash();	//pX؂蕶U폜
		}
		if(lpNode->bDir){
			strBuffer.AddBackslash();
		}
		strPath.Insert(0,strBuffer);
	}
	// o̓pX̏C
	UtilModifyPath(strPath);
}

