#include "stdafx.h"
#include "../ArchiverManager.h"
#include "ConfigDLL.h"

void CConfigDLL::load(CONFIG_SECTION &Config)
{
#define LOAD_ENTRY(x) EnableDLL[DLL_ID_##x]=Config.Data[_T(#x)].GetNParam(TRUE)
	LOAD_ENTRY(UNLHA);
	LOAD_ENTRY(7ZIP);
	LOAD_ENTRY(CAB);
	LOAD_ENTRY(TAR);
	LOAD_ENTRY(JACK);
	LOAD_ENTRY(YZ1);
	LOAD_ENTRY(UNARJ);
	LOAD_ENTRY(UNGCA);
	LOAD_ENTRY(UNRAR);
	LOAD_ENTRY(UNACE);
	LOAD_ENTRY(UNIMP);
	LOAD_ENTRY(UNBEL);
	LOAD_ENTRY(UNHKI);
	LOAD_ENTRY(BGA);
	LOAD_ENTRY(AISH);
	LOAD_ENTRY(UNISO);
}

void CConfigDLL::store(CONFIG_SECTION &Config)const
{
#define SAVE_ENTRY(x) Config.Data[_T(#x)]=EnableDLL[DLL_ID_##x]
	SAVE_ENTRY(UNLHA);
	SAVE_ENTRY(7ZIP);
	SAVE_ENTRY(CAB);
	SAVE_ENTRY(TAR);
	SAVE_ENTRY(JACK);
	SAVE_ENTRY(YZ1);
	SAVE_ENTRY(UNARJ);
	SAVE_ENTRY(UNGCA);
	SAVE_ENTRY(UNRAR);
	SAVE_ENTRY(UNACE);
	SAVE_ENTRY(UNIMP);
	SAVE_ENTRY(UNBEL);
	SAVE_ENTRY(UNHKI);
	SAVE_ENTRY(BGA);
	SAVE_ENTRY(AISH);
	SAVE_ENTRY(UNISO);
}

void CConfigDLL::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("Enable")));
}

void CConfigDLL::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("Enable")));
}
