#include "stdafx.h"
#include "../ArchiverCode/ArchiverTAR.h"
#include "ConfigManager.h"
#include "ConfigTAR.h"

// TAR/GZ/BZ2kݒ
void CConfigTAR::load(CONFIG_SECTION &Config)
{
	//GZIP̈kx
	GzipCompressLevel=Config.Data[_T("GZIPLevel")].GetNParam(GZIP_COMPRESS_LEVEL_LOWEST,GZIP_COMPRESS_LEVEL_HIGHEST,6);
	//BZIP2̈kx
	Bzip2CompressLevel=Config.Data[_T("BZIP2Level")].GetNParam(BZIP2_COMPRESS_LEVEL_LOWEST,BZIP2_COMPRESS_LEVEL_HIGHEST,9);
	//R[hϊ
	bConvertCharset=Config.Data[_T("ConvertCharset")].GetNParam(1);
}

void CConfigTAR::store(CONFIG_SECTION &Config)const
{
	//GZIP̈kx
	Config.Data[_T("GZIPLevel")]=GzipCompressLevel;
	//BZIP2̈kx
	Config.Data[_T("BZIP2Level")]=Bzip2CompressLevel;
	//R[hϊ
	Config.Data[_T("ConvertCharset")]=bConvertCharset;
}

void CConfigTAR::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("TAR")));
}

void CConfigTAR::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("TAR")));
}
