#pragma once
#include "Dlg_Base.h"
#include "../../resource.h"
#include "../../Utilities/Utility.h"

class CConfigDlgDetail : public CDialogImpl<CConfigDlgDetail>,public CMessageFilter,public IConfigDlgBase
{
protected:
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_DETAIL };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigVersion)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply(){return TRUE;}

	CConfigDlgDetail(){
		TRACE(_T("CConfigDlgDetail()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
	void LoadConfig(CConfigManager&){}
	void StoreConfig(CConfigManager&){}
};

