#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../Utilities/Utility.h"
#include "../../resource.h"
#include "../../ArchiverManager.h"
#include "../ConfigUpdate.h"

//====================================
// DLL̏ƍXV
//====================================
class CConfigDlgDLLUpdate : public CDialogImpl<CConfigDlgDLLUpdate>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigUpdate		m_Config;
	CButton				Check_AskUpdate;
	CUpDownCtrl			UpDown_Interval;
	CListViewCtrl		List_DLLVersion;
	CArchiverDLLManager	&ArchiverManager;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_DLL_UPDATER };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgDLLUpdate)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_BUTTON_DLL_UPDATE,OnDLLUpdate)
		COMMAND_ID_HANDLER(IDC_CHECK_DLL_ASK_UPDATE,OnCheckAskUpdate)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnDLLUpdate(WORD,WORD,HWND,BOOL&);
	LRESULT OnCheckAskUpdate(WORD,WORD,HWND,BOOL&);
	LRESULT OnApply();

	CConfigDlgDLLUpdate():ArchiverManager(CArchiverDLLManager::GetInstance()){
		TRACE(_T("CConfigDlgDLLUpdate()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

