#pragma once

#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../ArchiverCode/ArchiverTAR.h"
#include "../ConfigTAR.h"
#include "../../resource.h"

//====================================
// TAR̐ݒ荀
//====================================
class CConfigDlgTAR : public CDialogImpl<CConfigDlgTAR>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigTAR	m_Config;

	CEdit			Edit_GZIP_Level;
	CTrackBarCtrl	Track_GZIP_Level;

	CEdit			Edit_BZIP2_Level;
	CTrackBarCtrl	Track_BZIP2_Level;

	CButton	Check_ConvertCharset;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_TAR };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgTAR)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_HSCROLL(OnHScroll)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	void OnHScroll(int, short, HWND);

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

