#pragma once

class CInputDialog : public CDialogImpl<CInputDialog>,public CWinDataExchange<CInputDialog>
{
protected:
	CString &strInput;
	CString strMessage;
public:
	enum {IDD = IDD_DIALOG_INPUT};
	CInputDialog(LPCTSTR lpszMessage,CString &str):strInput(str),strMessage(lpszMessage){}

	// DDX}bv
	BEGIN_DDX_MAP(CInputDialog)
		DDX_TEXT(IDC_EDIT_INPUT,strInput)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CInputDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnButton)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnButton)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam){
		//bZ[Wݒ
		CStatic cStatic=GetDlgItem(IDC_STATIC_MESSAGE);
		cStatic.SetWindowText(strMessage);

		//DDXݒ
		DoDataExchange(FALSE);
		return TRUE;
	}
	void OnButton(UINT uNotifyCode, int nID, HWND hWndCtl){
		//DDXݒ
		DoDataExchange(TRUE);
		EndDialog(nID);
	}
};
