#include "stdafx.h"
#include "../ArchiverCode/ArchiverAISH.h"
#include "ConfigManager.h"
#include "ConfigAISH.h"

void CConfigAISH::load(CONFIG_SECTION &Config)
{
	//ISHGR[h^Cv
	EncodeType=(ISH_ENCODE_TYPE)Config.Data[_T("EncodeType")].GetNParam(0,ISH_ENCODE_TYPE_LAST_ITEM,0);
	//uuencode`FbNT
	UUEncodeChecksum=Config.Data[_T("UUEChecksum")].GetNParam(FALSE);
}

void CConfigAISH::store(CONFIG_SECTION &Config)const
{
	//ISHGR[h^Cv
	Config.Data[_T("EncodeType")]=EncodeType;
	//uuencode`FbNT
	Config.Data[_T("UUEChecksum")]=UUEncodeChecksum;
}

void CConfigAISH::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("AISH")));
}

void CConfigAISH::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("AISH")));
}
