#pragma once

#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/ArchiverCAB.h"
#include "../ConfigCAB.h"

//====================================
// CAB̐ݒ荀
//====================================
class CConfigDlgCAB : public CDialogImpl<CConfigDlgCAB>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigCAB	m_Config;

	CButton			Radio_CompressType[CAB_COMPRESS_TYPE_ITEM_COUNT];
	CEdit			Edit_LZX_Level;
	CTrackBarCtrl	Track_LZX_Level;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_CAB };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgCAB)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_HSCROLL(OnHScroll)
		COMMAND_RANGE_HANDLER(IDC_RADIO_CAB_MSZIP,IDC_RADIO_CAB_PLAIN, OnRadioCompressType)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	void OnHScroll(int, short, HWND);
	LRESULT OnRadioCompressType(WORD,WORD,HWND,BOOL&);

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

