#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/ArchiverJACK.h"
#include "../ConfigJACK.h"

//====================================
// JACK̐ݒ荀
//====================================
class CConfigDlgJACK : public CDialogImpl<CConfigDlgJACK>,public CWinDataExchange<CConfigDlgJACK>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigJACK	m_Config;

	CButton			Radio_SpecifyVolumeSize[2];
	int				VolumeSize;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}


public:
	enum { IDD = IDD_PROPPAGE_CONFIG_JACK };
	// DDX}bv
	BEGIN_DDX_MAP(CConfigDlgJACK)
		DDX_INT(IDC_EDIT_JACK_VOLUME_SIZE, VolumeSize)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgJACK)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_RANGE_HANDLER(IDC_RADIO_JACK_VOLUME_SIZE_USE_STORED_SETTING,IDC_RADIO_JACK_VOLUME_SIZE_SPECIFY_AT_COMPRESS, OnRadioVolumeSize)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnRadioVolumeSize(WORD,WORD,HWND,BOOL&);

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

