#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../Utilities/Utility.h"
#include "../ConfigOpenAction.h"

//======================================
// ֘AtŃt@CJƂ̓
//======================================

class CConfigDlgOpenAction : public CDialogImpl<CConfigDlgOpenAction>,public CMessageFilter,public IConfigDlgBase
{
protected:
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}
	CConfigOpenAction	m_Config;

	CButton Radio_OpenAction[OPENACTION_ITEM_COUNT];
	CButton Radio_OpenAction_Shift[OPENACTION_ITEM_COUNT];
	CButton Radio_OpenAction_Ctrl[OPENACTION_ITEM_COUNT];
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_OPENACTION };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgOpenAction)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

