#include "stdafx.h"
#include "TestArchive.h"
#include "ArchiverManager.h"
#include "ConfigCode/ConfigManager.h"
#include "ConfigCode/ConfigGeneral.h"
#include "Dialogs/LogListDialog.h"
#include "Dialogs/ProgressDlg.h"
#include "Utilities/StringUtil.h"

bool TestArchive(const std::list<CString> &rArcList,CConfigManager &ConfigManager)
{
	CArchiverDLLManager &ArchiverManager=CArchiverDLLManager::GetInstance();

	//XacRett̓`FbNÂߎgȂ

	//vOXo[
	CProgressDialog dlg;
	int nFiles=rArcList.size();
	dlg.Create(NULL);
	dlg.SetTotalFileCount(nFiles);
	dlg.ShowWindow(SW_SHOW);


	std::list<CString>::const_iterator ite=rArcList.begin();
	const std::list<CString>::const_iterator end=rArcList.end();

	//eXgʂi[
	std::vector<ARCLOG> LogArray;
	for(;ite!=end;++ite){
		//vOXo[i߂
		if(dlg.IsWindow())dlg.SetNextState(*ite);

		ARCLOG arcLog;
		arcLog.strFile=*ite;
		/*if(ConfGeneral.ScanVirus){
			if(FAILED(UtilScanVirus(*ite))){
				arcLog.Result=TEST_INFECTED;
				arcLog.strMsg.Format(IDS_ERROR_INFECTED_ARCHIVE,(LPCTSTR)*ite);
				arcLog.strFile=*ite;
				LogArray.push_back(arcLog);
				continue;
			}
		}*/

		//A[JConh擾
		//NOTE:DenyExtɂΏۍi荞݂͊ɍsĂ̂2͍sȂ
		CArchiverDLL *Archiver=ArchiverManager.GetArchiver(*ite,NULL);

		if(!Archiver){
			//---ΉnhȂ:𒲍
			//ʏ̃G[
			arcLog.strMsg.Format(IDS_ERROR_ILLEGAL_HANDLER,*ite);
			arcLog.Result=TEST_NOTARCHIVE;

			//UNICODE֌W̃`FbN
			if(!UtilCheckT2A(*ite)){
				//UNICODEɑΉĂȂ̂UNICODEt@C̃t@CƂ
				arcLog.strMsg+=_T("\r\n\r\n");
				arcLog.strMsg.AppendFormat(IDS_ERROR_UNICODEPATH);
			}
		}else{
			CString strTemp;
			arcLog.Result=Archiver->TestArchive(*ite,strTemp);
			arcLog.strMsg=Archiver->GetName();
			arcLog.strMsg+=_T("\r\n\r\n");
			arcLog.strMsg+=strTemp;
		}
		LogArray.push_back(arcLog);
	}
	//vOXo[
	if(dlg.IsWindow())dlg.DestroyWindow();

	//Oɕ\
	CLogListDialog LogDlg(CString(MAKEINTRESOURCE(IDS_LOGINFO_OPERATION_TESTARCHIVE)));
	LogDlg.SetLogArray(LogArray);
	LogDlg.DoModal();

	return true;
}


