#pragma once

class CEventDispatcher
{
protected:
	std::set<HWND> m_EventListener;

	virtual void dispatchEvent(UINT msg,WPARAM wParam=0,LPARAM lParam=0){
		for(std::set<HWND>::iterator ite=m_EventListener.begin();ite!=m_EventListener.end();++ite){
			::PostMessage(*ite,msg,wParam,lParam);
			//::SendMessage(*ite,msg,wParam,lParam);
		}
	}
public:
	CEventDispatcher(){}
	virtual ~CEventDispatcher(){}
	virtual void addEventListener(HWND hWnd){
		m_EventListener.insert(hWnd);
	}
	virtual void removeEventListener(HWND hWnd){
		m_EventListener.erase(hWnd);
	}
};
